/*
Bmp 4/8 Bits to GBA Converter By Bruno Vedder.
With modifications by Pete Elmore.
spr/spr_bonus.bmp Opened.
Bmp signature found.
Bmp width: 8
Bmp height: 32
Bmp not compressed: ok.
One plane.
Bmp is 4 Bit per pixel.
0 colors used. (0 mean full bpp).
Bmp data starts at 76h.
Allocating 128 bytes.
CMAP loaded.
Data loaded. */
namespace TILEINFO_spr_bonus {
  enum {
    w = 1,
    h = 4,
    size = 4,
  };
  const unsigned short palette[] = {
    0x3e0,0x7fff,0x5fff,0x3fff,0x1fff,0x3ff,0x2f7,0x1ef,0xe7,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
    };

  const unsigned char img[] = {

    // Tile [0 , 0] 
    0x0,0x70,0x7,0x0,
    0x0,0x60,0x7,0x0,
    0x77,0x66,0x64,0x76,
    0x37,0x13,0x44,0x76,
    0x40,0x14,0x32,0x7,
    0x60,0x24,0x63,0x6,
    0x67,0x6,0x70,0x76,
    0x77,0x0,0x0,0x77,
    
    // Tile [0 , 1] 
    0x0,0x60,0x6,0x0,
    0x0,0x50,0x6,0x0,
    0x56,0x25,0x53,0x66,
    0x56,0x22,0x22,0x65,
    0x30,0x22,0x22,0x5,
    0x50,0x33,0x33,0x5,
    0x56,0x5,0x50,0x65,
    0x66,0x0,0x0,0x66,
    
    // Tile [0 , 2] 
    0x0,0x70,0x7,0x0,
    0x0,0x60,0x7,0x0,
    0x77,0x66,0x64,0x76,
    0x37,0x13,0x44,0x76,
    0x40,0x14,0x32,0x7,
    0x60,0x24,0x63,0x6,
    0x67,0x6,0x70,0x76,
    0x77,0x0,0x0,0x77,
    
    // Tile [0 , 3] 
    0x0,0x80,0x8,0x0,
    0x0,0x80,0x7,0x0,
    0x88,0x77,0x76,0x88,
    0x78,0x56,0x76,0x87,
    0x60,0x55,0x65,0x7,
    0x70,0x56,0x76,0x7,
    0x78,0x7,0x70,0x87,
    0x88,0x0,0x0,0x88,
      };
  inline u16 *copyImage(u16 *vram) {
    for (u32 i = 0; i < sizeof(img) / 2; ++i) {
      *vram++ = img[i * 2] | (img[i * 2 + 1] << 8);
    }
    return vram;
  }
  inline u16 *copyPalette(u16 *pal) {
    for (u32 i = 0; i < sizeof(palette) / 2; ++i) {
      *pal++ = palette[i];
    }
    return pal;
  }
};
