/*
Bmp 4/8 Bits to GBA Converter By Bruno Vedder.
With modifications by Pete Elmore.
spr/spr_bullet.bmp Opened.
Bmp signature found.
Bmp width: 8
Bmp height: 128
Bmp not compressed: ok.
One plane.
Bmp is 4 Bit per pixel.
0 colors used. (0 mean full bpp).
Bmp data starts at 76h.
Allocating 512 bytes.
CMAP loaded.
Data loaded. */
namespace TILEINFO_spr_bullet {
  enum {
    w = 1,
    h = 16,
    size = 16,
  };
  const unsigned short palette[] = {
    0x0,0x842,0x1084,0x18c6,0x2108,0x294a,0x318c,0x39ce,0x4631,0x4e73,0x56b5,0x5ef7,0x6739,0x6f7b,0x77bd,0x7fff,
    };

  const unsigned char img[] = {

    // Tile [0 , 0] 
    0xb0,0xbb,0x0,0x0,
    0xfb,0xff,0xb,0x0,
    0xb0,0xff,0xbf,0xb,
    0x0,0xfb,0xff,0xbf,
    0x0,0xfb,0xff,0xbf,
    0xb0,0xff,0xbf,0xb,
    0xfb,0xff,0xb,0x0,
    0xb0,0xbb,0x0,0x0,
    
    // Tile [0 , 1] 
    0xb0,0xbb,0xb,0x0,
    0xb0,0xff,0x0,0x0,
    0x0,0xff,0xb,0x0,
    0x0,0xfb,0xbf,0xb,
    0xbb,0xff,0xff,0xb,
    0xff,0xff,0xff,0xbb,
    0xfb,0xbb,0xbb,0xbb,
    0xb0,0x0,0x0,0x0,
    
    // Tile [0 , 2] 
    0x0,0xf0,0xbb,0xb,
    0x0,0xfb,0xbf,0x0,
    0x0,0xfb,0xbf,0x0,
    0xbb,0xff,0xbf,0x0,
    0xff,0xff,0xbf,0xb,
    0xfb,0xff,0xff,0x0,
    0xb,0xb0,0xbf,0xb,
    0x0,0x0,0xb0,0xb,
    
    // Tile [0 , 3] 
    0x0,0xb0,0xbf,0xb,
    0x0,0x0,0xff,0xbb,
    0xff,0xbb,0xff,0x0,
    0xff,0xff,0xbf,0x0,
    0xbf,0xff,0xbf,0x0,
    0xb0,0xfb,0xbf,0x0,
    0x0,0xfb,0xbb,0x0,
    0x0,0x0,0xbb,0x0,
    
    // Tile [0 , 4] 
    0xb0,0x0,0x0,0xb,
    0xfb,0xb,0xb0,0xbf,
    0xfb,0xbf,0xfb,0xbf,
    0xfb,0xff,0xff,0xbf,
    0xb0,0xff,0xff,0xb,
    0x0,0xfb,0xbf,0x0,
    0x0,0xfb,0xbf,0x0,
    0x0,0xb0,0xb,0x0,
    
    // Tile [0 , 5] 
    0xb0,0xbf,0x0,0x0,
    0xfb,0xbf,0x0,0xbb,
    0xb0,0xff,0xfb,0xbf,
    0xb0,0xff,0xff,0xbf,
    0xb0,0xff,0xbf,0xb0,
    0xb0,0xff,0xb,0x0,
    0xb0,0xbb,0xb,0x0,
    0xb0,0xb,0x0,0x0,
    
    // Tile [0 , 6] 
    0xb0,0xfb,0xb,0x0,
    0x0,0xff,0xb,0x0,
    0x0,0xff,0xbf,0xb,
    0xb0,0xff,0xff,0xff,
    0xf0,0xff,0xff,0xbf,
    0xbb,0xbf,0xbb,0xbb,
    0xbb,0xb0,0x0,0xb0,
    0x0,0x0,0x0,0x0,
    
    // Tile [0 , 7] 
    0x0,0xf0,0xff,0x0,
    0x0,0xbb,0xff,0x0,
    0xb0,0xfb,0xbf,0x0,
    0xf0,0xff,0xbf,0xb0,
    0xbb,0xff,0xff,0xff,
    0xbb,0xbb,0xfb,0xbf,
    0x0,0x0,0x0,0xbb,
    0x0,0x0,0x0,0xb,
    
    // Tile [0 , 8] 
    0x0,0x0,0xbb,0xb,
    0x0,0xb0,0xff,0xbf,
    0xb0,0xfb,0xff,0xb,
    0xfb,0xff,0xbf,0x0,
    0xfb,0xff,0xbf,0x0,
    0xb0,0xfb,0xff,0xb,
    0x0,0xb0,0xff,0xbf,
    0x0,0x0,0xbb,0xb,
    
    // Tile [0 , 9] 
    0x0,0x0,0x0,0xb,
    0xbb,0xbb,0xbb,0xbf,
    0xbb,0xff,0xff,0xff,
    0xb0,0xff,0xff,0xbb,
    0xb0,0xfb,0xbf,0x0,
    0x0,0xb0,0xff,0x0,
    0x0,0x0,0xff,0xb,
    0x0,0xb0,0xbb,0xb,
    
    // Tile [0 , 10] 
    0xb0,0xb,0x0,0x0,
    0xb0,0xfb,0xb,0xb0,
    0x0,0xff,0xff,0xbf,
    0xb0,0xfb,0xff,0xff,
    0x0,0xfb,0xff,0xbb,
    0x0,0xfb,0xbf,0x0,
    0x0,0xfb,0xbf,0x0,
    0xb0,0xbb,0xf,0x0,
    
    // Tile [0 , 11] 
    0x0,0xbb,0x0,0x0,
    0x0,0xbb,0xbf,0x0,
    0x0,0xfb,0xbf,0xb,
    0x0,0xfb,0xff,0xfb,
    0x0,0xfb,0xff,0xff,
    0x0,0xff,0xbb,0xff,
    0xbb,0xff,0x0,0x0,
    0xb0,0xfb,0xb,0x0,
    
    // Tile [0 , 12] 
    0x0,0xb0,0xb,0x0,
    0x0,0xfb,0xbf,0x0,
    0x0,0xfb,0xbf,0x0,
    0xb0,0xff,0xff,0xb,
    0xfb,0xff,0xff,0xbf,
    0xfb,0xbf,0xfb,0xbf,
    0xfb,0xb,0xb0,0xbf,
    0xb0,0x0,0x0,0xb,
    
    // Tile [0 , 13] 
    0x0,0x0,0xb0,0xb,
    0x0,0xb0,0xbb,0xb,
    0x0,0xb0,0xff,0xb,
    0xb,0xfb,0xff,0xb,
    0xfb,0xff,0xff,0xb,
    0xfb,0xbf,0xff,0xb,
    0xbb,0x0,0xfb,0xbf,
    0x0,0x0,0xfb,0xb,
    
    // Tile [0 , 14] 
    0x0,0x0,0x0,0x0,
    0xb,0x0,0xb,0xbb,
    0xbb,0xbb,0xfb,0xbb,
    0xfb,0xff,0xff,0xf,
    0xff,0xff,0xff,0xb,
    0xb0,0xfb,0xff,0x0,
    0x0,0xb0,0xff,0x0,
    0x0,0xb0,0xbf,0xb,
    
    // Tile [0 , 15] 
    0xb0,0x0,0x0,0x0,
    0xbb,0x0,0x0,0x0,
    0xfb,0xbf,0xbb,0xbb,
    0xff,0xff,0xff,0xbb,
    0xb,0xfb,0xff,0xf,
    0x0,0xfb,0xbf,0xb,
    0x0,0xff,0xbb,0x0,
    0x0,0xff,0xf,0x0,
      };
  inline u16 *copyImage(u16 *vram) {
    for (u32 i = 0; i < sizeof(img) / 2; ++i) {
      *vram++ = img[i * 2] | (img[i * 2 + 1] << 8);
    }
    return vram;
  }
  inline u16 *copyPalette(u16 *pal) {
    for (u32 i = 0; i < sizeof(palette) / 2; ++i) {
      *pal++ = palette[i];
    }
    return pal;
  }
};
